<?php

/**
 * liquida_abono actions.
 *
 * @package    cobro_coactivo
 * @subpackage liquida_abono
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class liquida_abonoActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CBR_LIQUIDA_ABONO',
        'CBR_LIQUIDA_CONCEPTO',
        'CBR_CONCEPTO_DEUDA',
        'TS_BN'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'TS_BN' =>
        array(
            'id_ts_bn-id_bn' => 'CBR_LIQUIDA_ABONO'
        ),
        'CBR_LIQUIDA_CONCEPTO' =>
        array(
            'id_liquida_concepto' => 'CBR_LIQUIDA_ABONO'
        ),
        'CBR_CONCEPTO_DEUDA' =>
        array(
            'id_concepto_deuda' => 'CBR_LIQUIDA_CONCEPTO'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CBR_LIQUIDA_ABONO' =>
        array(
            'id_liquida_abono' => 'id_liquida_abono',
            'id_liquida_concepto' => 'id_liquida_concepto',
            'numero' => 'numero',
            'fecha_abono' => 'fecha_abono',
            'valor_abono' => 'valor_abono',
            'id_ts_bn' => 'id_ts_bn'
        ),
        'TS_BN' =>
        array(
            'codigo,||, - ,||,descripcion' => 'banco',
            'codigo' => 'codigo_bn',
            'descripcion' => 'descripcion_bn'
        ),
        'CBR_LIQUIDA_CONCEPTO' =>
        array(
            'cod_titulo' => 'cod_titulo',
            'id_remision_titulo_det' => 'id_remision_titulo_det',
            'id_concepto_deuda' => 'id_concepto_deuda',
            'fecha_ini' => 'fecha_ini',
            'fecha_fin' => 'fecha_fin',
            'dias' => 'dias',
            'id_tasa_interes' => 'id_tasa_interes',
            'id_ipc_ini' => 'id_ipc_ini',
            'id_ipc_fin' => 'id_ipc_fin',
            'valor_capital' => 'valor_capital',
            'valor_interes' => 'valor_interes',
            'valor_abono' => 'valor_abonos',
            'saldo' => 'saldo',
            'valor_acuerdo' => 'valor_acuerdo',
            'valor_embargo' => 'valor_embargo'
        ),
        'CBR_CONCEPTO_DEUDA' =>
        array(
            'descripcion' => 'descripcion_concepto'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'fecha_abono', 'numero', 'descripcion_bn'
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CBR_LIQUIDA_ABONO' =>
        array(
            'id_liquida_abono,a' => array('!=' => array(-1)),
            'id_liquida_abono,b' => array('=' => array('id_liquida_abono')),
            'id_liquida_concepto' => array('=' => array('id_liquida_concepto')),
            'numero' => array('=' => array('numero')),
            'id_ts_bn' => array('=' => array('id_ts_bn')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_liquida_abono'; //identificador de la tabla
    protected $id_names = array('id_liquida_abono'); //llave primaria
    protected $field_names = array('id_liquida_concepto', 'numero', 'fecha_abono',
        'valor_abono', 'id_ts_bn'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CBR_LIQUIDA_ABONO'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_liquida_abono'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();
            try {


                $id_liquida_concepto = $list_data_post[0]['id_liquida_concepto'];

                $sql = <<<EOD
update CBR_LIQUIDA_CONCEPTO 
set valor_abono = nvl((
    select sum(valor_abono) 
    from CBR_LIQUIDA_ABONO 
    where 
    id_liquida_concepto = $id_liquida_concepto
),0),

saldo = valor_capital + valor_interes - nvl((
    select sum(valor_abono) 
    from CBR_LIQUIDA_ABONO 
    where 
    id_liquida_concepto = $id_liquida_concepto
),0)

where
id_liquida_concepto = $id_liquida_concepto
EOD;
                $this->conn->execute($sql);

                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion update
        if ($Action == "UPDATE") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();
            try {


                $id_liquida_concepto = $list_data_post[0]['id_liquida_concepto'];

                $sql = <<<EOD
update CBR_LIQUIDA_CONCEPTO 
set valor_abono = nvl((
    select sum(valor_abono) 
    from CBR_LIQUIDA_ABONO 
    where 
    id_liquida_concepto = $id_liquida_concepto
),0),

saldo = valor_capital + valor_interes - nvl((
    select sum(valor_abono) 
    from CBR_LIQUIDA_ABONO 
    where 
    id_liquida_concepto = $id_liquida_concepto
),0)

where
id_liquida_concepto = $id_liquida_concepto
EOD;
                $this->conn->execute($sql);

                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion remove
        if ($Action == "REMOVE") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();
            try {


                $id_liquida_concepto = $request['id_liquida_concepto'];

                $sql = <<<EOD
update CBR_LIQUIDA_CONCEPTO 
set valor_abono = nvl((
    select sum(valor_abono) 
    from CBR_LIQUIDA_ABONO 
    where 
    id_liquida_concepto = $id_liquida_concepto
),0),

saldo = valor_capital + valor_interes - nvl((
    select sum(valor_abono) 
    from CBR_LIQUIDA_ABONO 
    where 
    id_liquida_concepto = $id_liquida_concepto
),0)

where
id_liquida_concepto = $id_liquida_concepto
EOD;
                $this->conn->execute($sql);

                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {

            $id_liquida_abono = $request['id_liquida_abono'];

            $sql = <<<EOD
SELECT
    *
FROM CBR_LIQUIDA_ABONO
where
id_liquida_abono = $id_liquida_abono
EOD;

            $records = CN_TABLE::executeSQL($sql);

            $request['id_liquida_concepto'] = $records[0]['id_liquida_concepto'];
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */
        $id_liquida_concepto = $request['id_liquida_concepto'];
        $valor_abono = $request['valor_abono'];

        /*
         *  Generar errores en $errors
         */
        //sentencia sql
        $sql = <<<EOD
 select
cont.id_liquida_concepto,
cont.valor_capital + cont.valor_interes as valor,
nvl(sum(novdes.valor_abono),0) as valor_abono

from CBR_LIQUIDA_CONCEPTO cont

left join CBR_LIQUIDA_ABONO novdes
on novdes.id_liquida_concepto = cont.id_liquida_concepto

where
cont.id_liquida_concepto = $id_liquida_concepto

group by
cont.id_liquida_concepto,
cont.valor_capital,
cont.valor_interes
EOD;
        //ejecuta el sql
        $records = CN_TABLE::executeSQL($sql);

        //Valida abono no supere total - 20200224
        if (count($records) > 0) {

            $valor = $records[0]['valor'];
            $valor_abono_cont = $records[0]['valor_abono'];

            if (($valor_abono_cont + $valor_abono) > $valor) {

                $valor_abono_text = number_format($valor_abono);
                $valor_total_text = number_format($valor);

                $errors['mensaje'] = "El valor abono($valor_abono_text) supera el total del concepto($valor_total_text), verificar.";
                $errors['servicio'] = "abono_concepto";
                $logger->info("El valor abono($valor_abono_text) supera el total del concepto($valor_total_text), verificar.");
            }
        }


        //sentencia sql
        $sql = <<<EOD
SELECT
valor_capital,
valor_interes,
saldo,

valor_acuerdo,
valor_abono_calc as valor_abono_calc

FROM cbr_liquida_concepto

where
id_liquida_concepto = $id_liquida_concepto 
and valor_abono = 0
EOD;
        //ejecuta el sql
        $records = CN_TABLE::executeSQL($sql);

        //Valida abono no supere total - 20200224
        if (count($records) > 0) {

            $valor_abono_calc = $records[0]['valor_abono_calc'];

            if ($valor_abono < $valor_abono_calc) {

                $valor_abono_text = number_format($valor_abono);
                $valor_total_text = number_format($valor_abono_calc);

                $errors['mensaje'] = "El valor abono($valor_abono_text) debe superar el abono del acuerdo($valor_total_text), verificar.";
                $errors['servicio'] = "liquida_abono";
                $logger->info("El valor abono($valor_abono_text) debe superar el abono del acuerdo($valor_total_text), verificar.");
            }
        }

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */
        $id_liquida_concepto = $request['id_liquida_concepto'];
        $valor_abono = $request['valor_abono'];

        /*
         *  Generar errores en $errors
         */
        //sentencia sql
        $sql = <<<EOD
select
cont.id_liquida_concepto,
cont.valor_capital + cont.valor_interes as valor,
nvl(sum(novdes.valor_abono),0) as valor_abono

from CBR_LIQUIDA_CONCEPTO cont

left join CBR_LIQUIDA_ABONO novdes
on novdes.id_liquida_concepto = cont.id_liquida_concepto

where
cont.id_liquida_concepto = $id_liquida_concepto

group by
cont.id_liquida_concepto,
cont.valor_capital,
cont.valor_interes
EOD;
        //ejecuta el sql
        $records = CN_TABLE::executeSQL($sql);

        //Valida abono no supere total - 20200224
        if (count($records) > 0) {

            $valor = $records[0]['valor'];
            $valor_abono_cont = $records[0]['valor_abono'];

            if (($valor_abono_cont + $valor_abono) > $valor) {

                $valor_abono_text = number_format($valor_abono);
                $valor_total_text = number_format($valor);

                $errors['mensaje'] = "El valor abono($valor_abono_text) supera el total del concepto($valor_total_text), verificar.";
                $errors['servicio'] = "abono_concepto";
                $logger->info("El valor abono($valor_abono_text) supera el total del concepto($valor_total_text), verificar.");
            }
        }


        //sentencia sql
        $sql = <<<EOD
SELECT
valor_capital,
valor_interes,
saldo,

valor_acuerdo,
valor_abono_calc as valor_abono_calc

FROM cbr_liquida_concepto

where
id_liquida_concepto = $id_liquida_concepto 
and 1 = (

    select count(*) 
    FROM cbr_liquida_abono    
    where
    id_liquida_concepto = $id_liquida_concepto  

)
EOD;
        //ejecuta el sql
        $records = CN_TABLE::executeSQL($sql);

        //Valida abono no supere total - 20200224
        if (count($records) > 0) {

            $valor_abono_calc = $records[0]['valor_abono_calc'];

            if ($valor_abono < $valor_abono_calc) {

                $valor_abono_text = number_format($valor_abono);
                $valor_total_text = number_format($valor_abono_calc);

                $errors['mensaje'] = "El valor abono($valor_abono_text) debe superar el abono del acuerdo($valor_total_text), verificar.";
                $errors['servicio'] = "liquida_abono";
                $logger->info("El valor abono($valor_abono_text) debe superar el abono del acuerdo($valor_total_text), verificar.");
            }
        }

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

}
